diff a/src/hotspot/cpu/x86/assembler_x86.cpp b/src/hotspot/cpu/x86/assembler_x86.cpp
--- a/src/hotspot/cpu/x86/assembler_x86.cpp
+++ b/src/hotspot/cpu/x86/assembler_x86.cpp
@@ -5730,10 +5730,14 @@
 
 void Assembler::rdtsc() {
   emit_int16(0x0F, 0x31);
 }
 
+void Assembler::rdtscp() {
+  emit_int24(0x0F, 0x01, (unsigned char)0xF9);
+}
+
 // copies data from [esi] to [edi] using rcx pointer sized words
 // generic
 void Assembler::rep_mov() {
   // REP
   // MOVSQ
diff a/src/hotspot/cpu/x86/assembler_x86.hpp b/src/hotspot/cpu/x86/assembler_x86.hpp
--- a/src/hotspot/cpu/x86/assembler_x86.hpp
+++ b/src/hotspot/cpu/x86/assembler_x86.hpp
@@ -2044,10 +2044,11 @@
   void rcpps(XMMRegister dst, XMMRegister src);
 
   void rcpss(XMMRegister dst, XMMRegister src);
 
   void rdtsc();
+  void rdtscp();
 
   void ret(int imm16);
 
   void roll(Register dst);
 
diff a/src/hotspot/cpu/x86/x86_64.ad b/src/hotspot/cpu/x86/x86_64.ad
--- a/src/hotspot/cpu/x86/x86_64.ad
+++ b/src/hotspot/cpu/x86/x86_64.ad
@@ -12640,10 +12640,36 @@
   format %{ "# TLS is in R15" %}
   ins_encode( /*empty encoding*/ );
   ins_pipe(ialu_reg_reg);
 %}
 
+instruct rdtsc(rax_RegL dst, rdx_RegL tmp) %{
+  match(Set dst (Timestamp));
+  effect(DEF dst, KILL tmp);
+
+  format %{ "RDTSC" %}
+  ins_encode %{
+    __ rdtsc();
+    __ shlptr(rdx, 32);
+    __ orptr(rax, rdx);
+  %}
+  ins_pipe(ialu_reg_reg);
+%}
+
+instruct rdtscp(rax_RegL dst, rdx_RegL tmp, rcx_RegL dead) %{
+  match(Set dst (TimestampSerial));
+  effect(DEF dst, KILL tmp, KILL dead);
+
+  format %{ "RDTSCP" %}
+  ins_encode %{
+    __ rdtscp();
+    __ shlptr(rdx, 32);
+    __ orptr(rax, rdx);
+  %}
+  ins_pipe(ialu_reg_reg);
+%}
+
 
 //----------PEEPHOLE RULES-----------------------------------------------------
 // These must follow all instruction definitions as they use the names
 // defined in the instructions definitions.
 //
diff a/src/hotspot/share/c1/c1_Compiler.cpp b/src/hotspot/share/c1/c1_Compiler.cpp
--- a/src/hotspot/share/c1/c1_Compiler.cpp
+++ b/src/hotspot/share/c1/c1_Compiler.cpp
@@ -233,10 +233,12 @@
   case vmIntrinsics::_putCharStringU:
 #ifdef JFR_HAVE_INTRINSICS
   case vmIntrinsics::_counterTime:
 #endif
   case vmIntrinsics::_getObjectSize:
+  case vmIntrinsics::_shipilev_magic_sizeOf:
+  case vmIntrinsics::_shipilev_magic_addressOf:
     break;
   case vmIntrinsics::_blackhole:
     break;
   default:
     return false; // Intrinsics not on the previous list are not available.
diff a/src/hotspot/share/c1/c1_LIRGenerator.cpp b/src/hotspot/share/c1/c1_LIRGenerator.cpp
--- a/src/hotspot/share/c1/c1_LIRGenerator.cpp
+++ b/src/hotspot/share/c1/c1_LIRGenerator.cpp
@@ -1335,15 +1335,40 @@
 
   // Get the answer.
   __ move(new LIR_Address(klass, in_bytes(Klass::modifier_flags_offset()), T_INT), result);
 }
 
+void LIRGenerator::do_addressOf(Intrinsic* x) {
+  assert(x->number_of_arguments() == 1, "wrong type");
+  LIR_Opr reg = rlock_result(x);
+
+  LIRItem value(x->argument_at(0), this);
+  value.load_item();
+
+#ifdef _LP64
+  __ move(value.result(), reg, NULL);
+#else
+  LIR_Opr res = new_register(T_INT);
+  __ move(value.result(), res, NULL);
+  __ convert(Bytecodes::_i2l, res, reg);
+#endif
+}
+
+void LIRGenerator::do_sizeOf(Intrinsic* x) {
+  assert(x->number_of_arguments() == 1, "wrong type");
+  do_sizeOf_impl(x, 0);
+}
+
 void LIRGenerator::do_getObjectSize(Intrinsic* x) {
   assert(x->number_of_arguments() == 3, "wrong type");
+  do_sizeOf_impl(x, 2);
+}
+
+void LIRGenerator::do_sizeOf_impl(Intrinsic* x, int arg_idx) {
   LIR_Opr result_reg = rlock_result(x);
 
-  LIRItem value(x->argument_at(2), this);
+  LIRItem value(x->argument_at(arg_idx), this);
   value.load_item();
 
   LIR_Opr klass = new_register(T_METADATA);
   load_klass(value.result(), klass, nullptr);
   LIR_Opr layout = new_register(T_INT);
@@ -2963,10 +2988,12 @@
   case vmIntrinsics::_getClass:       do_getClass(x);      break;
   case vmIntrinsics::_getObjectSize:  do_getObjectSize(x); break;
   case vmIntrinsics::_currentCarrierThread: do_currentCarrierThread(x); break;
   case vmIntrinsics::_currentThread:  do_vthread(x);       break;
   case vmIntrinsics::_scopedValueCache: do_scopedValueCache(x); break;
+  case vmIntrinsics::_shipilev_magic_sizeOf:         do_sizeOf(x);        break;
+  case vmIntrinsics::_shipilev_magic_addressOf:      do_addressOf(x);     break;
 
   case vmIntrinsics::_dlog:           // fall through
   case vmIntrinsics::_dlog10:         // fall through
   case vmIntrinsics::_dabs:           // fall through
   case vmIntrinsics::_dsqrt:          // fall through
diff a/src/hotspot/share/c1/c1_LIRGenerator.hpp b/src/hotspot/share/c1/c1_LIRGenerator.hpp
--- a/src/hotspot/share/c1/c1_LIRGenerator.hpp
+++ b/src/hotspot/share/c1/c1_LIRGenerator.hpp
@@ -258,10 +258,12 @@
   void do_getObjectSize(Intrinsic* x);
   void do_currentCarrierThread(Intrinsic* x);
   void do_scopedValueCache(Intrinsic* x);
   void do_vthread(Intrinsic* x);
   void do_JavaThreadField(Intrinsic* x, ByteSize offset);
+  void do_sizeOf(Intrinsic* x);
+  void do_addressOf(Intrinsic* x);
   void do_FmaIntrinsic(Intrinsic* x);
   void do_MathIntrinsic(Intrinsic* x);
   void do_LibmIntrinsic(Intrinsic* x);
   void do_ArrayCopy(Intrinsic* x);
   void do_CompareAndSwap(Intrinsic* x, ValueType* type);
@@ -477,10 +479,12 @@
   void profile_arguments(ProfileCall* x);
   void profile_parameters(Base* x);
   void profile_parameters_at_call(ProfileCall* x);
   LIR_Opr mask_boolean(LIR_Opr array, LIR_Opr value, CodeEmitInfo*& null_check_info);
 
+  void do_sizeOf_impl(Intrinsic* x, int arg_idx);
+
  public:
   Compilation*  compilation() const              { return _compilation; }
   FrameMap*     frame_map() const                { return _compilation->frame_map(); }
   ciMethod*     method() const                   { return _method; }
   BlockBegin*   block() const                    { return _block; }
diff a/src/hotspot/share/classfile/classFileParser.cpp b/src/hotspot/share/classfile/classFileParser.cpp
--- a/src/hotspot/share/classfile/classFileParser.cpp
+++ b/src/hotspot/share/classfile/classFileParser.cpp
@@ -5208,10 +5208,11 @@
   // Not yet: supers are done below to support the new subtype-checking fields
   ik->set_nonstatic_field_size(_field_info->_nonstatic_field_size);
   ik->set_has_nonstatic_fields(_field_info->_has_nonstatic_fields);
   assert(_fac != nullptr, "invariant");
   ik->set_static_oop_field_count(_fac->count[STATIC_OOP]);
+  ik->set_nonstatic_oop_field_count(_fac->count[NONSTATIC_OOP]);
 
   // this transfers ownership of a lot of arrays from
   // the parser onto the InstanceKlass*
   apply_parsed_class_metadata(ik, _java_fields_count);
 
diff a/src/hotspot/share/classfile/vmIntrinsics.hpp b/src/hotspot/share/classfile/vmIntrinsics.hpp
--- a/src/hotspot/share/classfile/vmIntrinsics.hpp
+++ b/src/hotspot/share/classfile/vmIntrinsics.hpp
@@ -596,10 +596,22 @@
   do_intrinsic(_notifyJvmtiVThreadEnd, java_lang_VirtualThread, notifyJvmtiEnd_name, void_method_signature, F_RN)       \
   do_intrinsic(_notifyJvmtiVThreadMount, java_lang_VirtualThread, notifyJvmtiMount_name, bool_void_signature, F_RN)     \
   do_intrinsic(_notifyJvmtiVThreadUnmount, java_lang_VirtualThread, notifyJvmtiUnmount_name, bool_void_signature, F_RN) \
   do_intrinsic(_notifyJvmtiVThreadHideFrames, java_lang_VirtualThread, notifyJvmtiHideFrames_name, bool_void_signature, F_RN) \
                                                                                                                         \
+  do_intrinsic(_shipilev_magic_timestamp,             net_shipilev_Magic, timestamp_name,            void_long_signature,   F_SN) \
+    do_name(timestamp_name,             "timestamp")                                                                              \
+  do_intrinsic(_shipilev_magic_timestamp_serial,      net_shipilev_Magic, timestampSerial_name,      void_long_signature,   F_SN) \
+    do_name(timestampSerial_name,       "timestampSerial")                                                                        \
+  do_intrinsic(_shipilev_magic_sizeOf,                net_shipilev_Magic, sizeOf_name,               object_long_signature, F_SN) \
+    do_name(sizeOf_name,                "sizeOf0")                                                                                \
+  do_intrinsic(_shipilev_magic_addressOf,             net_shipilev_Magic, addressOf_name,            object_long_signature, F_SN) \
+    do_name(addressOf_name,             "addressOf0")                                                                             \
+  do_intrinsic(_shipilev_magic_getReferencedObjects,  net_shipilev_Magic, getReferencedObjects_name, object_object_array_int_signature, F_SN)  \
+    do_name(getReferencedObjects_name,  "getReferencedObjects")                                                                  \
+    do_class(net_shipilev_Magic,        "net/shipilev/Magic")                                                           \
+                                                                                                                        \
   /* support for UnsafeConstants */                                                                                     \
   do_class(jdk_internal_misc_UnsafeConstants,      "jdk/internal/misc/UnsafeConstants")                                 \
                                                                                                                         \
   /* support for Unsafe */                                                                                              \
   do_class(jdk_internal_misc_Unsafe,               "jdk/internal/misc/Unsafe")                                          \
diff a/src/hotspot/share/classfile/vmSymbols.hpp b/src/hotspot/share/classfile/vmSymbols.hpp
--- a/src/hotspot/share/classfile/vmSymbols.hpp
+++ b/src/hotspot/share/classfile/vmSymbols.hpp
@@ -155,10 +155,11 @@
   template(sun_net_www_ParseUtil,                     "sun/net/www/ParseUtil")                    \
   template(java_util_Iterator,                        "java/util/Iterator")                       \
   template(java_lang_Record,                          "java/lang/Record")                         \
   template(sun_instrument_InstrumentationImpl,        "sun/instrument/InstrumentationImpl")       \
   template(sun_invoke_util_ValueConversions,          "sun/invoke/util/ValueConversions")         \
+  template(java_lang_Runtime,                         "java/lang/Runtime")                        \
                                                                                                   \
   template(jdk_internal_loader_NativeLibraries,       "jdk/internal/loader/NativeLibraries")      \
   template(jdk_internal_loader_BuiltinClassLoader,    "jdk/internal/loader/BuiltinClassLoader")   \
   template(jdk_internal_loader_ClassLoaders_AppClassLoader,      "jdk/internal/loader/ClassLoaders$AppClassLoader")      \
   template(jdk_internal_loader_ClassLoaders_PlatformClassLoader, "jdk/internal/loader/ClassLoaders$PlatformClassLoader") \
@@ -594,12 +595,14 @@
   template(stackchunk_signature,                      "Ljdk/internal/vm/StackChunk;")             \
   template(vthread_signature,                         "Ljava/lang/VirtualThread;")                \
   template(object_void_signature,                     "(Ljava/lang/Object;)V")                    \
   template(object_int_signature,                      "(Ljava/lang/Object;)I")                    \
   template(long_object_long_signature,                "(JLjava/lang/Object;)J")                   \
+  template(object_long_signature,                     "(Ljava/lang/Object;)J")                    \
   template(object_boolean_signature,                  "(Ljava/lang/Object;)Z")                    \
   template(object_object_signature,                   "(Ljava/lang/Object;)Ljava/lang/Object;")   \
+  template(object_object_array_int_signature,         "(Ljava/lang/Object;[Ljava/lang/Object;)I") \
   template(string_void_signature,                     "(Ljava/lang/String;)V")                    \
   template(string_int_signature,                      "(Ljava/lang/String;)I")                    \
   template(string_byte_array_signature,               "(Ljava/lang/String;)[B")                   \
   template(string_bool_byte_array_signature,          "(Ljava/lang/String;Z)[B")                  \
   template(throwable_signature,                       "Ljava/lang/Throwable;")                    \
